<template>
    <!-- filter -->
    <div class="box p-5 mb-10 bg-white rounded-lg shadow-md dark:bg-gray-800">
    <form autocomplete="off" @submit.prevent="filterForm.get('/employee/user', { preserveScroll: true, preserveState: true })">
      <div class="flex items-center text-base font-medium text-gray-700 dark:text-gray-200 mb-4">
        <b>Search</b>
      </div>
      <div class="w-full flex justify-center items-center mb-4">
        <div class="flex w-full">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full mr-2">
              <label for="employee-name" class="text-sm font-medium text-gray-700 dark:text-gray-300 mb-2">Employee Name</label>
              <input v-model="filterForm.name" id="employee-name" class="input flex-grow border border-gray-300 rounded-lg py-2 px-4 focus:outline-none focus:ring-2 focus:ring-blue-500 focus:border-transparent dark:bg-gray-700 dark:text-gray-200" placeholder="Enter name" />
            </div>
          </div>
        </div>
      </div>
      <div class="flex flex-row-reverse gap-x-2">
        <button class="btn bg-green-600 text-white text-sm md:text-base py-2 md:py-3 px-4 md:px-6 font-medium rounded-lg hover:bg-green-700 focus:outline-none focus:ring-2 focus:ring-green-500">Search</button>
      </div>
    </form>
    <div class="md:flex md:justify-left mt-4" v-if="currentUser.role.create_user">
      <Link href="/employee/user/create" class="inline-block md:w-auto md:mx-2 font-medium text-lime-500 hover:text-lime-600">
        <button class="btn bg-blue-700 text-white text-sm md:text-base py-2 md:py-3 px-4 md:px-6 font-medium rounded-lg hover:bg-blue-800 focus:outline-none focus:ring-2 focus:ring-blue-500">
          <Icon icon="fa-solid fa-circle-plus" class="mr-2"></Icon> Add New Employee
        </button>
      </Link>

      <a href="/employee/user/export"
      class="btn bg-blue-700 text-white text-sm md:text-base py-2 md:py-3 px-4 md:px-6 font-medium rounded-lg hover:bg-blue-800 focus:outline-none focus:ring-2 focus:ring-blue-500">
                    Download Excel
                </a>
    </div>
  </div>

    <div class="relative shadow-md sm:rounded-lg w-[90vw] md:w-full">
        
        <div class="overflow-auto">
            <table class="w-full table-fixed  text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400 border-collapse">
    <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
      <tr>
        <th scope="col" class="p-4 w-16"></th>
        <th scope="col" class="p-4 w-60 md:w-auto">Employee Name</th>
        <th scope="col" class="p-4 w-40 md:w-auto">Role</th>
        <th scope="col" class="p-4 w-40 md:w-auto">Date of Join
          <button @click="() => sortBy('dojAsc')" type="button"
                  v-if="filters.sortBy !== 'dojAsc' && filters.sortBy !== 'dojDesc'">
            <Icon icon="fa-solid fa-sort" class="ml-2 text-xs"></Icon>
          </button>
          <button @click="() => sortBy('dojDesc')" type="button"
                  v-else-if="filters.sortBy === 'dojAsc'">
            <Icon icon="fa-solid fa-sort-up" class="ml-2 text-xs"></Icon>
          </button>
          <button @click="() => sortBy('dojAsc')" type="button"
                  v-else-if="filters.sortBy === 'dojDesc'">
            <Icon icon="fa-solid fa-sort-down" class="ml-2 text-xs"></Icon>
          </button>
        </th>
        <th scope="col" class="p-4 w-40 md:w-auto">Department</th>
        <th scope="col" class="p-4 w-40 md:w-auto">Action</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="user in users.data" :key="user.id" class="bg-white border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-50 dark:hover:bg-gray-600">
        <td class="p-4">
        </td>
        <td class="p-4 dark:text-gray-200">
          {{ user.name }}
        </td>
        <td class="p-4 dark:text-gray-200">
          {{ user.role.name }}
        </td>
        <td class="p-4 dark:text-gray-200">
          {{ user.doj }}
        </td>
        <td class="p-4 dark:text-gray-200">
          {{ user.department_staff_detail?.department.name }}
        </td>
        <td class="p-4 flex items-center">
          <Link v-if="currentUser.role.update_user" :href="`/employee/user/${user.id}/edit`" class="text-gray-500 hover:text-blue-900">
            <Icon icon="fa-solid fa-pen-to-square" class="text-xl"></Icon>
          </Link>
          <div class="mx-2"></div>
          <Link v-if="currentUser.can_view_employees" :href="`/employee/user/${user.id}`" class="text-gray-500 hover:text-green-900">
            <Icon icon="fa-eye" class="text-xl"></Icon>
          </Link>
          <div class="mx-2"></div>
          <button @click="deleteUser(user.id)" v-if="currentUser.role.delete_user" class="text-gray-500 hover:text-red-900">
            <Icon icon="fa-trash-can" class="text-xl cursor-pointer"></Icon>
          </button>
        </td>
      </tr>
    </tbody>
  </table>
        </div>
    </div>



    <Pagination :data="users"></Pagination>
</template>

<script setup>
import { computed, onMounted } from "vue";
import { Link, useForm, usePage } from "@inertiajs/vue3";
import Pagination from "@/Components/Pagination.vue";
import { initDropdowns } from "flowbite";

const page = usePage();
const currentUser = computed(() => page.props.currentUser)

const props = defineProps({
    users: Object,
    departments: Array,
    filters: Object,
});

onMounted(() => {
    initDropdowns();
});

//selection
const selectionForm = useForm({
    selected_users: [],
});

function deleteUser(userId) {
    if (confirm("Are you sure to delete?")) {
        selectionForm.selected_users.push(userId);
        selectionForm.delete("/employee/user", {
            preserveScroll: true,
            preserveState: false,
        });
    }
}

//filter
const filterForm = useForm({
    name: props.filters.name ?? null,
    department: props.filters.department ?? 'All Department',
    sortBy: null
});

function sortBy(value) {
    filterForm.sortBy = value;
    filterForm.get('/employee/user', {
        preserveScroll: true,
        preserveState: true,
    });
}
</script>

